function add()
    local a = {}
    for n = 1,5000 do
        a[n]=0
    end
    return a
end

dofile("sys/lua/worldz.lua")

turret=add()
tx=add()
ty=add()
timg=add()
timg2=add()
tcd=add()
trot=add()
tby=add()
target=add()
trm=add()

pr=add()
prx=add()
pry=add()
pt=add()
pby=add()
prot=add()
primg=add()
ptm=add()

function getpos(x, y, dir, speed)
    return x + math.sin(math.rad(dir)) * speed, y + -math.cos(math.rad(dir)) * speed
end


function ssp(s,p)
    parse('sv_soundpos "'..s..'" '..player(p,"x")..' '..player(p,"y"))
end
function freeline(x1, y1, x2, y2)
    local len = math.sqrt((x1 - x2)^2 + (y1 - y2)^2)
    len = math.floor(len)
    for k = 20, len do
        local x, y = getpos(x1, y1, -math.deg(math.atan2(x1 - x2, y1 - y2)), k)
        if tile(math.floor(x / 32), math.floor(y / 32), "wall") then
            return false
        end
    end
    return true
end

function freelinep(p,d)
    return freeline(player(p,"x"),player(p,"y"),player(d,"x"),player(d,"y"))
end

addhook("always","alw")
function alw()
    for n = 1,tn do
        if turret[n]>0 then
            if trm[n]>0 then
                trm[n]=trm[n]-1
                if trm[n]<1 then
                    turret[n]=0
                    freeimage(timg[n])
                    freeimage(timg2[n])
                end
            end
            for d = 1,32 do
                if hitable(tby[n],d) and radius(tx[n],ty[n],player(d,"x"),player(d,"y"),400) and freeline(tx[n],ty[n],player(d,"x"),player(d,"y")) then
                    if target[n]<1 then
                        target[n]=d
                    end
                end
            end
            if target[n]>0 then
                if radius(tx[n],ty[n],player(target[n],"x"),player(target[n],"y"),400)==false or hitable(tby[n],target[n])==false then
                    target[n]=0
                end
                if target[n]>0 then
                    trot[n]=deg(tx[n],ty[n],player(target[n],"x"),player(target[n],"y"))
                    imagepos(timg[n],tx[n],ty[n],trot[n])
                    if tcd[n]>0 then
                        tcd[n]=tcd[n]-1
                    else
                        tcd[n]=5
                        spwns(tby[n],target[n],tx[n],ty[n],trot[n])
                        imagescale(timg[n],1,0.8)
                        tween_scale(timg[n],80,1,1)
                        local rot = trot[n]
                        if rot < -90 then rot = rot + 360 end
                        local angle = math.rad(math.abs( rot + 90 )) - math.pi
                        local x = tx[n] + math.cos(angle) * 9
                        local y = ty[n] + math.sin(angle) * 9
                        parse('effect "smoke" '..x..' '..y..' 1 3')
                    end
                end
            end
        end
    end
    for n = 1, prn do
        if pr[n]>0 then
            if ptm[n]>80 then
                for d = 1,32 do
                    if hitable(pby[n],d) and radius(prx[n],pry[n],player(d,"x"),player(d,"y"),64) then
                        ss("summon.ogg",prx[n],pry[n])
                        ptm[n]=80
                        local pole = image("gfx/worldz/dinamit.bmp",prx[n],pry[n],0)
                        imagescale(pole,0,0)
                        imagealpha(pole,0)
                        tween_scale(pole,500,0.5,0.5)
                        tween_alpha(pole,1000,1)
                        timer(1500,"freeimage",pole)
                        local pole = image("gfx/gui_load.bmp",prx[n],pry[n],0)
                        imagescale(pole,6,6)
                        imageblend(pole,1)
                        tween_rotateconstantly(pole,15)
                        imagealpha(pole,0)
                        tween_scale(pole,1000,0.5,0.5)
                        tween_alpha(pole,800,1)
                        timer(1500,"freeimage",pole)
                    end
                end
            else
                if ptm[n]>0 then
                    ptm[n]=ptm[n]-1
                    if ptm[n]<1 then
                        pr[n]=0
                    end
                end
                if ptm[n]>40 then
                    for d = 1,32 do
                        if hitable(pby[n],d) and radius(prx[n],pry[n],player(d,"x"),player(d,"y"),100) then
                            fl[d]=2
                            frot[d]=deg(player(d,"x"),player(d,"y"),prx[n],pry[n])-70
                            noc[d]=3
                        end
                    end
                end
                if ptm[n]==40 then
                    ss("weapons/explode4.wav",prx[n],pry[n])
                    parse('effect "smoke" '..prx[n]..' '..pry[n]..' 30 30')
                    parse('effect "smoke" '..prx[n]..' '..pry[n]..' 30 30')
                    parse('effect "smoke" '..prx[n]..' '..pry[n]..' 30 30')
                    local uo = image("gfx/flare3.bmp",prx[n],pry[n],0)
                    imageblend(uo,1)
                    imagecolor(uo,255,255,0)
                    tween_alpha(uo,1000,0)
                    imagescale(uo,1.5,1.5)
                    local uos = image("gfx/hud_radar_ring.png",prx[n],pry[n],0)
                    imageblend(uos,1)
                    imagecolor(uos,255,255,0)
                    tween_alpha(uos,1000,0)
                    imagescale(uos,0,0)
                    tween_scale(uos,200,0.8,0.8)
                    shk(prx[n],pry[n],500,30)
                end
                if ptm[n]<=40 and ptm[n]>=35 then
                    for d = 1,32 do
                        if hitable(pby[n],d) and radius(prx[n],pry[n],player(d,"x"),player(d,"y"),100) then
                            fl[d]=6
                            frot[d]=deg(prx[n],pry[n],player(d,"x"),player(d,"y"))
                            fnm[d]="Dynamte"
                            hitm[d]=4
                            dmg(pby[n],d,"Dynamite",150)
                        end
                    end
                end
            end
        end
    end
end

tn=1

function addt(p)
    tn = tn + 1
    local n = tn
    tx[n]=player(p,"x")
    ty[n]=player(p,"y")
    timg2[n]=image("gfx/worldz/stand.bmp",tx[n],ty[n],1)
    timg[n]=image("gfx/worldz/xbow.bmp",tx[n],ty[n],1)
    turret[n]=1
    tby[n]=p
    trm[n]=5000
end
prn=1

function spwns(p)
    prn=prn+1
    local n = prn
    pby[n]=p
    pr[n]=1
    prx[n]=player(p,"x")
    pry[n]=player(p,"y")
    ptm[n]=85
    local poled = image("gfx/worldz/dinamit.bmp",prx[n],pry[n],0)
    imagescale(poled,0.5,0.5)
    imagealpha(poled,1)
    tween_scale(poled,500,0.3,0.3)
    tween_alpha(poled,500,0)
    timer(500,"freeimage",poled)
    ssp("weapons/mine_activate.wav",p)
end